import { Logging, LoggingBase } from "./index";
import { randomBytes } from "crypto";

Logging.log("test")
Logging.log("i", "am", { a: "an" }, 1000);
Logging.error(new Error("fehler 001"));
Logging.debug("Some Debug infos");
Logging.errorMessage("i", "am", "an", "error");

Logging.log("\x1b[31m\x1b[31m\x1b[31m\x1b[31m\x1b[31m\x1b[31m TEST \x1b[31m\x1b[31m\x1b[31m")

let err = new Error()
if (typeof err.stack !== "string") console.log("Stacktrace invalid", err.stack)

let cus = new LoggingBase({ name: "test" });
cus.log("Hello from custom Logger")

let cus2 = new LoggingBase("test2");
cus2.log("Hello from custom Logger 2")

let cus22 = new LoggingBase("test2");
cus22.log("Hello from custom Logger 22")
cus2.log("Hello from custom Logger 2")
cus22.log("Hello from custom Logger 22")
cus2.log("Hello from custom Logger 2")
cus22.log("Hello from custom Logger 22")
cus2.log("Hello from custom Logger 2")
cus22.log("Hello from custom Logger 22")
cus2.log("Hello from custom Logger 2")
cus22.log("Hello from custom Logger 22")
cus2.log("Hello from custom Logger 2")

Logging.console_out = false;
async function benchmark(count: number, message_size: number) {
   await Logging.waitForSetup();
   const randData = randomBytes(message_size).toString("hex")
   const t = process.hrtime();
   for (let i = 0; i < count; i++) {
      Logging.log(randData)
   }
   const diff = process.hrtime(t);
   const NS_PER_SEC = 1e9;
   await Logging.waitForSetup();
   const ns = diff[0] * NS_PER_SEC + diff[1];
   console.log(`Benchmark took ${ns / 1000000}ms for ${count} messages with a size of ${message_size} characters`);
   console.log(`This is equal to ${(ns / 1000000) / count} ms per message`)
}

Logging.waitForSetup().then(async () => {
   console.log("Large data benchmark:")
   await benchmark(7000, 50000);

   console.log("Realdata data benchmark:")
   await benchmark(100000, 100)
});